<?php
require_once('config.php');

function get_friends_ids($my_friends){
    $result = array();

    foreach ($my_friends['data'] as $friend){
        $result[] = $friend['id'];
    }

    return $result;
}
function timedisplay($timestamp) { 
    $etime = time() - $timestamp;
    if( $etime < 1 ) {
        return 'less than 1 second ago';
    }
    $a = array(	12 * 30 * 24 * 60 * 60	=>  'year',
                30 * 24 * 60 * 60		=>  'month',
                24 * 60 * 60			=>  'day',
                60 * 60				    =>  'hour',
                60					    =>  'minute',
                1					    =>  'second');

    foreach( $a as $secs => $str ) {
        $d = $etime / $secs;
        if( $d >= 1 ) {
            $r = round( $d );
            return $r . ' ' . $str . ( $r > 1 ? 's' : '' ) . ' ago';
        }
    }
}

function strpos_array($haystack, $needles) {
    if ( is_array($needles) ) {
        foreach ($needles as $str) {
            if ( is_array($str) ) {
                $pos = strpos_array($haystack, $str);
            } else {
                $pos = strpos($haystack, $str);
            }
            if ($pos !== FALSE) {
                return $pos;
            }
        }
    } else {
        return strpos($haystack, $needles);
    }
}

//
//  Unicode aware trim function, takes a string and 
//  truncates to given length, adding an elipsis character
//
function unicode_trim($content, $trim_to_chars = 2000) {   
    $content = trim(html_entity_decode($content, ENT_NOQUOTES,'UTF-8'));
    $elip = '';
    if (mb_strlen($content) > $trim_to_chars) 
    {
        $content = mb_substr($content, 0, $trim_to_chars);
        $elip = '&hellip;';
    }
    return htmlspecialchars($content) . $elip;
}

function ieOrFirefox($user_agent){
$user_agent = $_SERVER['HTTP_USER_AGENT'];
$pos = strpos($user_agent, "MSIE");
$broswerArray = array();
if($pos > 0){
	$version = intval(substr($user_agent, ($pos+5), 3));
	$browserArray = array("browser" => "ie", "version" => $version);
	
}else {
	$mozillaArray = explode("/",substr($user_agent, -13));
	if($mozillaArray[0] == "Firefox"){
		$version = intval($mozillaArray[1]);
		$browserArray = array("browser" => "fi", "version" => $version);
	}else return false;
}
return $browserArray;
}

function createBreadCrumbs($breadCrumbsArray){
    require_once "urlBuilder.php";
    require_once "config.php";

    $urlBuilder = new urlBuilder(vB_SITE_ROOT);

    $html = "<a href=\"category_list.php\">Home</a> > ";
    $html .= "<a href=\"forums.php\">Forums</a>";

    foreach((array)$breadCrumbsArray as $navBit){
        $html .= " > " . createHtmlNavBit($navBit['forumid'], $navBit['title'], $navBit['threadcount'], $urlBuilder);
}
    return $html;
}

function createHtmlNavBit($forumid, $title, $threadcount, $urlBuilder){
    
    $urlParamsArray = array("forumid" => $forumid, "forum_forumname" => $title, "threadcount" => $threadcount);
    $sendForumTo = $urlBuilder->buildPaginationUrl("forum",$urlParamsArray);
    return "<a href=\"$sendForumTo\">$title</a>";

}

function cache_start() {
    ob_start();
}
function display_header( $customcss = null, $customjs = null, $verbatim_header = '' )
{ 
    cache_start();
	$script_name = basename($_SERVER['SCRIPT_NAME']);
	$discover_selected = ($script_name == 'category_list.php' || $script_name == 'index.php') ? ' selected' : '';
	$explore_selected = ($script_name == 'category_stream.php' || $script_name == 'category_item.php') ? ' selected' : '';
	$forums_selected = ($script_name == 'forums.php') ? ' selected' : '';
    $canvas_url = parse_url(FACEBOOK_CANVAS_URL);
    $should_use_https = $canvas_url['scheme'] == 'https';
?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en"  xmlns:og="http://ogp.me/ns#" xmlns:fb="http://ogp.me/ns/fb#">

<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<?php 
    if(strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 8')){
        echo "<meta http-equiv=\"X-UA-Compatible\" content=\"IE=8\" />\n";
    } 
?>
    <title>vBulletin Forum</title>
<?php
    if(!empty($customcss)) {
        foreach($customcss as $csspath) {
?>
    <link href="<?php echo $csspath; ?>?<?php echo BUILD_TAG; ?>" rel="stylesheet" type="text/css" />
<?php }} ?>
    <link href="_css/common.css?<?php echo BUILD_TAG; ?>" rel="stylesheet" type="text/css" />
    <link href="_css/dashboard.css?<?php echo BUILD_TAG; ?>" rel="stylesheet" type="text/css" />
    <link href="_css/lists.css?<?php echo BUILD_TAG; ?>" rel="stylesheet" type="text/css" />
    <link href="_css/bbcode.css?<?php echo BUILD_TAG; ?>" rel="stylesheet" type="text/css" />
	<link href="_css/jquery.qtip.min.css?<?php echo BUILD_TAG; ?>" rel="stylesheet" type="text/css" />
    
	<?php if(defined('GA_KEY')) { ?>
    <script type="text/javascript">
		var _gaq = _gaq || [];
		_gaq.push(['_setAccount', '<?php echo GA_KEY; ?>']);
		_gaq.push(['_trackPageview']);

		(function() {
		var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
		ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
		var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
		})();
	</script>
    <?php } ?>
    <link href="_css/custom.css?<?php echo BUILD_TAG; ?>" rel="stylesheet" type="text/css" />
    <script src="//ajax.googleapis.com/ajax/libs/jquery/1.6.4/jquery.min.js"></script>
        <?php
    if(!empty($customjs)) {
        foreach($customjs as $jspath) {
?>
    <script src="<?php echo $jspath; ?>?<?php echo BUILD_TAG; ?>"></script>
<?php }} 
echo $verbatim_header;
?>
</head>
<body>
	<div id="fb-root"></div>
	<script src="http://connect.facebook.net/en_US/all.js"></script>
	<script>
		<?php if($should_use_https) echo 'FB._https = true;'; ?>
        FB.init({
			appId: '<?php echo FACEBOOK_APP_ID; ?>',
			channelUrl: '<?php echo FACEBOOK_APP_SITEURL . 'channel.html'; ?>',
			status: true,
            xfbml: true
		});
		FB.Canvas.EarlyFlush.setCollectionMode(FB.Canvas.EarlyFlush.COLLECT_AUTOMATIC);
		document.fbAppId = <?php echo FACEBOOK_APP_ID; ?>;
	</script>
	<div id="mainwrap">
		<div id="header">
			<h1><a href="category_list.php" alt="<?php echo FACEBOOK_APP_NAME; ?>"></a></h1>

			<div id="search">
				<input type="text" id="search-txt" onkeypress=" if(isEnter(event)){ searchValidation(); return false; }" data-hint="Find it here" />
				<a onclick="searchValidation(); return false" title="Search">Search</a>
				<img src="_css/wedge_search.png" />
			</div>
			<ul>
				<li class="discover<?php echo $discover_selected; ?>"><div><div><a href="category_list.php">Discover</a></div></div></li>
				<li class="explore<?php echo $explore_selected; ?>"><div><div><a href="category_stream.php?category=All_All">Explore</a></div></div></li>
				<li class="forums<?php echo $forums_selected; ?>"><div><div><a href="forums.php">Forums</a></div></div></li>                  
			</ul>
            <?php if (!empty($_SESSION['logged_in_to_vb']) && $_SESSION['logged_in_to_vb'] == true) { ?>
            <p id="hello">Hello, <a href="category_stream.php?category=User_Profile"><?php echo $_SESSION['username']; ?></a>!
            </p>           
            <?php } else { ?>
			<p id="hello"><a href="register_form.php">Login / Register</a></p>
            <?php } ?>
		</div>
		<div id="maincontainer">
<?php }

function display_footer($expires_timestamp = 0) { 
    $bottomad = defined('BOTTOM_AD') ? BOTTOM_AD : '' ;
    if(!empty($bottomad)) { ?><div class="bottomad"><?php echo $bottomad; ?></div><?php } ?>
                <div id="suggestionbox"></div>
			</div>
		<div class="clear"></div>
	</div>
	<script>
        window.read_only = <?php echo ((!defined('READ_ONLY') || !READ_ONLY) ? 'false' : 'true'); ?>;
        window.site_root = '<?php echo vB_SITE_ROOT; ?>';
		window.signed_request = '<?php echo $_REQUEST['signed_request']; ?>';
        window.app_root = '<?php echo FACEBOOK_CANVAS_URL; ?>';
	</script>
    <script src="_js/common.js?<?php echo BUILD_TAG; ?>"></script>
	<script src="_js/jquery.qtip.min.js?<?php echo BUILD_TAG; ?>"></script>
    <script src="https://services.vbulletin.com/fb.js"></script>    
</body>
</html>


<?php 
    cache_end($expires_timestamp);
}

function cache_end($expires_timestamp = 0) {
    $PageContent = ob_get_contents();
    
    if($expires_timestamp > 0 && $expires_timestamp > time()) {
        $HashID = md5($PageContent . implode("", $_GET));
        
        $DoIDsMatch = (isset($_SERVER['HTTP_IF_NONE_MATCH']) and strstr($HashID, $_SERVER['HTTP_IF_NONE_MATCH']));
        
        if ($DoIDsMatch) {
            header('HTTP/1.1 304 Not Modified');
			header('p3p: CP="NOI ADM DEV PSAi COM NAV OUR OTR STP IND DEM"');
            header('Connection: close');
            exit;
        }
		else {
			header('HTTP/1.1 200 OK');
			header('p3p: CP="NOI ADM DEV PSAi COM NAV OUR OTR STP IND DEM"');
			header('Content-Type: text/html; charset=utf-8');
			header('Cache-Control: max-age=' . ($expires_timestamp - time()) .', must-revalidate');
			// header('Expires: '.gmdate('D, d M Y H:i:s', $expires_timestamp).' GMT');
			header('ETag: ' . $HashID);
			header('Content-Length: ' . strlen($PageContent));
			ob_end_flush();
		}
    } else {
		header('HTTP/1.1 200 OK');
		header('p3p: CP="NOI ADM DEV PSAi COM NAV OUR OTR STP IND DEM"');
		header('Content-Type: text/html; charset=utf-8');
		header('Content-Length: ' . strlen($PageContent));
		ob_end_flush();
	}
}
?>
